# -*- coding: utf-8 -*-

from general_helpers import max_string_length
from general_helpers import datestr_to_python
from general_helpers import set_form_id_and_get_submit_button

from openstudio import Invoice, InvoicesHelper, Customer, Order


from decimal import Decimal, ROUND_HALF_UP

import cStringIO
import weasyprint
import openpyxl


@auth.requires(auth.has_membership(group_id='Admins') or \
                auth.has_permission('read', 'customers_orders'))
def edit():
    '''
        :return: shows order
    '''
    response.title = T('Order #') + request.vars['coID']
    response.subtitle = T('Edit')
    response.view = 'general/only_content.html'

    coID = request.vars['coID']

    order = Order(coID)
    cuID = order.order.auth_customer_id
    # Info table
    info = TABLE(THEAD(TR(TH(T('Ordered on')),
                          TH(T('Status')))),
                 _class='table')

    # Display status
    for field in db.customers_orders:
        field.readable = False
        field.writable = False

    db.customers_orders.Status.readable = True
    db.customers_orders.Status.writable = True

    crud.messages.record_updated = T('Saved')
    form = crud.update(db.customers_orders, coID)

    result = set_form_id_and_get_submit_button(form, 'MainForm')
    form = result['form']
    submit = result['submit']

    form = DIV(XML('<form id="MainForm" action="#" enctype="multipart/form-data" method="post">'),
               form.custom.widget.Status,
               form.custom.end)

    #status = form

    # status = represent_customers_orders_status(order.order.Status, order.order)
    # Display ordered on
    ordered_on = represent_datetime(order.order.DateCreated, order.order)
    info.append(TR(TD(ordered_on), TD(form)))

    # Info content
    content = DIV(DIV(info, _class='col-md-3 no-padding-left'))

    # Display items
    rows = order.get_order_items_rows()

    header = THEAD(TR(TH(T('Product')),
                      TH(T('Description')),
                      TH(SPAN(T('Amount incl. VAT'), _class='right')),
                      TH(),
                        )
                     )
    table = TABLE(header, _class='table table-striped table-hover order-items')


    for i, row in enumerate(rows):
        repr_row = list(rows[i:i + 1].render())[0]

        table.append(TR(TD(repr_row.ProductName),
                        TD(repr_row.Description),
                        TD(SPAN(repr_row.TotalPriceVAT, _class='right')),
                        TD())
                     )

    # Display totals
    amounts = order.get_amounts()

    footer = TFOOT(TR(TD(),
                    TD(B(T('Subtotal'))),
                    TD(SPAN(CURRSYM, ' ', format(amounts.TotalPrice, '.2f'), _class='bold right')),
                    TD()
                    ),
                  TR(TD(),
                    TD(B(T('VAT'))),
                    TD(SPAN(CURRSYM, ' ', format(amounts.VAT, '.2f'), _class='bold right')),
                    TD()
                    ),
                  TR(TD(),
                    TD(B(T('Total'))),
                    TD(SPAN(CURRSYM, ' ', format(amounts.TotalPriceVAT, '.2f'), _class='bold right')),
                    TD()
                    ))
    table.append(footer)

    content.append(table)

    back = os_gui.get_button('back', edit_get_return_url(cuID))

    return dict(content=content, back=back, save=submit)


def edit_get_return_url(cuID):
    '''
        Returns back url for customers orders
    '''
    url = URL('finance', 'orders')

    if session.orders_edit_back == 'customers_orders':
        return URL('customers', 'orders', vars={'cuID':cuID})

    return url